//
//  CB_Filter_Linear.java
//  CBSim
//
//  Created by Loren Petrich on 10/4/09.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

public class CB_Filter_Grayscale extends CB_Filter
{
	// Transformation matrices:
	public static final double TransformMatrices[][] =
	{
		{0.299, 0.587, 0.114},
		{0.340841450085, 0.580912815482, 0.0782457344332},
		{0.150317227739, 0.722407271325, 0.127275500935},
		{0.0336717653952, 0.114595364984, 0.851732869621}
	};
	
	private double TransformMatrix[];
	
	public void SetTransformType(int cbtype)
	{
		TransformMatrix = TransformMatrices[cbtype];
	}
	
	public void DoTransform(double[] ClrIn, double[] ClrOut)
	{
		
		double sum = 0;
		for (int j=0; j<3; j++)
			sum += TransformMatrix[j]*ClrIn[j];
		for (int i=0; i<3; i++)
		{
			ClrOut[i] = sum;
		}
	}
}
