//
//  ImageFromScreenshot.java
//  CBSim
//
//  Created by Loren Petrich on 5/30/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

import java.awt.*;
import java.awt.image.*;
import java.util.*;

public class ImageFromScreenshot extends Component
{
	// Takes a shot of as much as possible
	public static BufferedImage Get()
	{
		return Get(GetScreenRect());
	}
	
	// Takes a shot of whatever is in some rectangle Rect
	public static BufferedImage Get(Rectangle Rect)
	{
		BufferedImage Img;
		try
		{
			Robot rbt = new Robot();
			Img = rbt.createScreenCapture(Rect);
		}
		catch (Exception ex)
		{
			return null;
		}
		return Img;
	}
	
	// Finds the largest bounds that can be captured
	public static Rectangle GetScreenRect()
	{
		Dimension ScreenSize = Toolkit.getDefaultToolkit().getScreenSize();
		return new Rectangle(ScreenSize);
	}
	
	// Finds the boundaries of all the displays that the computer is using
	public static Rectangle[] GetAllScreenRects()
	{
		Vector<Rectangle> RectList = new Vector<Rectangle>();
		
		GraphicsEnvironment GE = GraphicsEnvironment.getLocalGraphicsEnvironment();
		GraphicsDevice GDList[] = GE.getScreenDevices();
		for(GraphicsDevice GD: GDList)
		{
			GraphicsConfiguration GCList[] =GD.getConfigurations();
			for (GraphicsConfiguration GC: GCList)
			{
				Rectangle GCRect = GC.getBounds();
				
				// Avoid duplications
				boolean IsPresent = false;
				for (Rectangle MemRect: RectList)
				{
					if (GCRect.equals(MemRect))
					{
						IsPresent = true;
						break;
					}
				}
				
				if (!IsPresent)
				{
					RectList.add(GCRect);
				}
			}
		}
		
		Rectangle Dummy[] = new Rectangle[1];
		return RectList.toArray(Dummy);
	}


}
